--ported from BlitzBasic to Lve by NB; original code: 2D quad texturer by james @ hi - toro . com

pixBuf = love.image.newImageData( 512, 256 ) -- initialize PO2 buffer
pixCls = love.image.newImageData("black.png") -- uses black bitmap for clearscreen
pix = love.graphics.newImage( pixBuf )
texBuf = love.image.newImageData("texture.png")

local pp = 0 -- frame limiter

local testX = {40, 260, 300, 4} -- quad coordinates
local testY = {4, 40, 100, 180}

-- cos movement
distance=70
angle=0
pointx=0
pointy=0

-- ------------------------------------------------------------------------------------------------------
function love.update(dt)
	collectgarbage('collect')
	
	pp = pp + dt
	if pp > 1/15 then
		clearPix()
		quadTexture()
		pointx = ( math.cos(angle) * distance )
		pointy = ( math.sin(angle) * distance )
		angle = angle + .1
		testX = {40 + pointx, 260 + pointy, 300+pointx, 4+pointx}
		testY = {4 + pointx, 40+pointy, 100+pointy, 180+pointy}
		pp = 0
	end
	love.timer.sleep(1)
end

-- ------------------------------------------------------------------------------------------------------
function love.draw()
	love.graphics.draw( pix, pixOffsetX, pixOffsetY, 0, 2, 2, 0, 0 )
	love.graphics.rectangle( 'line', 80, 120, 640, 360 ) -- draw frame around viewport
	love.graphics.print("FPS: " .. love.timer.getFPS(), 1, 1 )
end

-- ------------------------------------------------------------------------------------------------------
function Dist(x0, y0, x1, y1)
	local sqr = math.sqrt
	return sqr(((x1 - x0) * (x1 - x0)) + ((y1 - y0) * (y1 - y0)))
end

-- ------------------------------------------------------------------------------------------------------
function quadTexture()
	local IW = 256 -- image width
	local IH = 256 -- image height
	local leftside = Dist(testX[1], testY[1], testX[4], testY[4])
	local rightside = Dist(testX[2], testY[2], testX[3], testY[3])
	local long1
	local long2
	local short1
	local short2
	local plotdir
	local mfloor = math.floor
	
	if leftside > rightside then
		-- left side longer...
		long1 = 1
		long2 = 4
		short1 = 2
		short2 = 3
		plotdir = 1
	else
		-- right side longer...
		long1 = 2
		long2 = 3
		short1 = 1
		short2 = 4
		plotdir = -1
	end
	local ystepper = 1 / Dist(testX[long1], testY[long1], testX[long2], testY[long2])
	local ylimit = 1 + ystepper
	local ypos = 0
	local plotx, ploty

	while ypos < ylimit do
		local xlong = (testX[long1] * (1 - ypos) + testX[long2] * ypos)
		local ylong = (testY[long1] * (1 - ypos) + testY[long2] * ypos)
		local xshort = (testX[short1] * (1 - ypos) + testX[short2] * ypos)
		local yshort = (testY[short1] * (1 - ypos) + testY[short2] * ypos)
		local xstepper = 1 / Dist(xlong, ylong, xshort, yshort)
		local xlimit = 1 + xstepper
		local xpos = 0

		while xpos < xlimit do
			if plotdir == 1 then
				plotx = mfloor((xlong * (1 - xpos)) + (xshort * xpos))
				ploty = mfloor(((ylong * (1 - xpos)) + (yshort * xpos)))
			else
				plotx = mfloor(((xshort * (1 - xpos)) + (xlong * xpos)))
				ploty = mfloor(((yshort * (1 - xpos)) + (ylong * xpos)))
			end
			
			if (plotx > 0) and (ploty > 0) then
				if (plotx < 319) and (ploty < 179) and (IW * xpos) < IW and (IH * ypos) < IH then
							-- read pixel color from texture image
							local r, g, b, a = texBuf:getPixel(mfloor(IW*xpos), mfloor(IH*ypos))
							-- draw to buffer
							pixBuf:setPixel(plotx, ploty, r, g, b, a )
				end
			end
			xpos = xpos + xstepper
		end
		ypos = ypos + ystepper
	end
	updatePix(80, 120)
end

-- ------------------------------------------------------------------------------------------------------
function updatePix( pOX, pOY )
	pixOffsetX = pOX
	pixOffsetY = pOY
	pix = love.graphics.newImage( pixBuf )
	pix:setFilter( "nearest", "nearest" )
end

-- ------------------------------------------------------------------------------------------------------
function clearPix()
	pixBuf:paste(pixCls, 0, 0)
end